Bug 102677 - rpm refuses to manage dependencies correctly
rpm refuses to manage dependencies correctly
Status: CLOSED RAWHIDE
Product: Red Hat Raw Hide
Classification: Retired
Component: rpm (Show other bugs)
1.0
i386 Linux
high Severity high
: ---
: ---
Assigned To: Jeff Johnson
Mike McLean
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-08-19 15:52 EDT by Jan Pazdziora
Modified: 2005-10-31 17:00 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-08-20 12:37:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Pazdziora 2003-08-19 15:52:46 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 Galeon/1.2.10 (X11; Linux i686; U;) Gecko/20030314

Description of problem:
After I upgraded to rpm-4.2.1-0.30 from rawhide, I was no longer
able to reinstall mozilla without noise about failed dependencies.
I have even run rpm --rebuilddb but to no avail. Downgrade of rpm
to rpm-4.2-0.69 from Red Hat Linux 9 distribution made it possible
to work with the rpm again.

Version-Release number of selected component (if applicable):
rpm-4.2.1-0.30

How reproducible:
Always

Steps to Reproduce:
1. install rpm 4.2.1-0.30
2. try to work with some packages that have dependencies    

Actual Results:  [root@charybda tmp]# rpm -Uvh mozilla-1.3-0_rh8_xft.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-1.3-0_rh8_xft
        libnspr4.so is needed by mozilla-1.3-0_rh8_xft
        libplc4.so is needed by mozilla-1.3-0_rh8_xft
        libplds4.so is needed by mozilla-1.3-0_rh8_xft
[root@charybda tmp]# rpm -Uvh mozilla-1.3-0_rh8_xft.i386.rpm
mozilla-nspr-1.3-0_rh8_xft.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-1.3-0_rh8_xft
[root@charybda tmp]# rpm -Uvh mozilla-nspr-1.3-0_rh8_xft.i386.rpm 
Preparing...                ########################################### [100%]
   1:mozilla-nspr           ########################################### [100%]
[root@charybda tmp]# rpm -Uvh mozilla-1.3-0_rh8_xft.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-1.3-0_rh8_xft
[root@charybda tmp]# rpm -qa | grep mozilla
mozilla-nspr-1.3-0_rh8_xft
[root@charybda tmp]# rpm --rebuilddb
[root@charybda tmp]# rpm -Uvh mozilla-1.3-0_rh8_xft.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-1.3-0_rh8_xft


Expected Results:  The mozilla packages should have installed seamlessly.

Additional info:
Comment 1 Jeff Johnson 2003-08-20 10:44:13 EDT
What happens if you add --promoteepoch when installing?
Comment 2 Jan Pazdziora 2003-08-20 11:03:41 EDT
You mean when installing the rpm or when installing the mozilla package?
Comment 3 Jeff Johnson 2003-08-20 11:09:56 EDT
mozilla, the problem you reported.
Comment 4 Jan Pazdziora 2003-08-20 11:31:24 EDT
Yes, using rpm with --promoteepoch helps.

[root@charybda tmp]# rpm -Uvh mozilla-1.3-0_rh8_xft.i386.rpm
mozilla-nspr-1.3-0_rh8_xft.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-1.3-0_rh8_xft
[root@charybda tmp]# rpm -Uvh --promoteepoch mozilla-1.3-0_rh8_xft.i386.rpm
mozilla-nspr-1.3-0_rh8_xft.i386.rpm 
Preparing...                ########################################### [100%]
   1:mozilla-nspr           ########################################### [ 50%]
   2:mozilla                ########################################### [100%]
[root@charybda tmp]# rpm -Uvh mozilla-nss-1.3-0_rh8_xft.i386.rpm
galeon-1.2.10-1.i386.rpm 
error: Failed dependencies:
        mozilla-nspr = 1.3-0_rh8_xft is needed by mozilla-nss-1.3-0_rh8_xft
        mozilla = 1.3-0_rh8_xft is needed by galeon-1.2.10-1
[root@charybda tmp]# rpm -Uvh --promoteepoch mozilla-nss-1.3-0_rh8_xft.i386.rpm
galeon-1.2.10-1.i386.rpm 
Preparing...                ########################################### [100%]
   1:galeon                 ########################################### [ 50%]
   2:mozilla-nss            ########################################### [100%]

Is this the expected behaviour (meaning I'll have to use it from now on),
or is it a bug in mozilla or rpm package?

Thanks.
Comment 5 Jeff Johnson 2003-08-20 12:37:21 EDT
OK, then this is expected behavior. rpm-4.2.1 is treating missing
Epoch: in dependency comparisons as identical to Epoch: 0.

Certain packages have had broken dependencies for years, all now fixed in
the latest beta.

So your choices when using rpm-4.2.1 to install mixtures of fixed and broken
packages when you encounter a problem are
    a) use --promoteepoch to revert the behavior
    b) look for a later version with corrected dependencies in Raw Hide.
Comment 6 Jan Pazdziora 2003-08-20 12:43:09 EDT
Thanks. The trouble with the latest mozillas in Raw Hide is that
there doesn't seem to be any correcponding galeon. But I think
new bug will be needed for that. Thank you.

Note You need to log in before you can comment on or make changes to this bug.